#ifndef ScanRootGui_HH
#define ScanRootGui_HH

#include "ScanRoot.h"
#include "TROOT.h"
#include "TControlBar.h"
#include "TGLabel.h"
#include "TGTextBuffer.h"
#include "TGTextEntry.h"
#include "TGButton.h"
#include "PelTools.h"
#include "TString.h"
#include "TGLabel.h"
#include "TGTextBuffer.h"
#include "TGTextEntry.h"
#include "TGButton.h"
#include "TGMsgBox.h"
#include "TGClient.h"
#include "TDialog.h"
#include <iostream>
#include <TGClient.h>
#include <TGButton.h>
#include <TGMenu.h>
#include "TApplication.h"
#include "TGMsgBox.h"
#include "TGFileDialog.h" 
#include "TGTab.h"
#include "TBrowser.h"
#include "TCanvas.h"

using namespace std;


class ScanRootGui : public ScanRoot
{
  private:
     TGMainFrame*    fMainFrame2357;
     PelTools*       mTools;
		 
		 bool            isGUIActive;
		 
		 TGTextEntry*    mText[4];
		 TGRadioButton*  mRadio[6];
		 
		 enum {kRadioALL, kRadioNEW, kRadioSMEAR, kRadioNOSMEAR,
		       kRadioDEBUGOFF, kRadioDEBUGON};
		 
		 enum {kTextINPUT, kTextOUT, kTextHIST, kTextL2};
		 
             
  public:
                     ScanRootGui(bool = false);
                     ScanRootGui(TDirectory*);
    virtual          ~ScanRootGui();  
        
    void             makeGUI();
		
		
    void             help(); 
    void             openInputGUI();
		void             rewindGUI();
    void             closeInputGUI();
    void             openOutputGUI();
    void             closeOutputGUI();
    void             outputSaveModeGUI(bool);
    void             smearingModeGUI(bool);
    void             hacGUI();
    void             saveHistGUI();
    void             addHistGUI();
    void             loadL2GUI();
    void             unloadL2GUI();
    void             zeroGUI();
    void             zeroAllGUI();
    void             goGUI();
		void             skipGUI();
    void             setNParGUI();
    void             pelTools() { if(mTools) mTools->menu();}
    void             quitGUI();
    void             debugGUI(bool);
    void             initGUI();
    void             finishGUI();
		void             canvas() { new TCanvas();}
		void             browser() { new TBrowser();}
		void             runMacro();
		void             execLine();

    
  ClassDef(ScanRootGui,1)
};
#endif
