#include "ScanRoot.h"
#include "TCutG.h"
#include "TFile.h"

TCutG* banana[100];

/////////////////////////////////////////////////////////////////////
bool l2trigger(short npar,float *par)
{
  // this trigger saves events only if the pair
  // (X,Y) =(par[1],par[2]) is inside the
  // graphical cut. If not, the event is not saved
  if(banana[0]->IsInside(par[1],par[2])) return true;
  return false;
}
/////////////////////////////////////////////////////////////////////
void configureL2(ScanRoot *scan)
{
  // opening banana file for input
  TFile *f=new TFile("banana.root");
  // getting pointers to bananas
  banana[0] = (TCutG*)f->Get("banana0;1");
  // remember not to close the file.
  // if you close the file the banana will not be
  // available anymore
  
  // this line links the software trigger function
  // to the scan program.
  scan->l2trigger = &l2trigger;
}
/////////////////////////////////////////////////////////////////////
void initL2()
{
}
/////////////////////////////////////////////////////////////////////
void finishL2()
{
}
